;=================================================================
; Project Name	: Ms Access Shift Menu
; Version		: 1.0
; Compiler		: Masm32 package v9.0
; IDE			: RadAsm v2.2.1.0
; Tested		: Win98, XP
; Date			: 27-02-2007 - 28-02-2007
; Author		: Rudy Rooroh
;=================================================================

.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include MsAShiftMenu.inc

.code

start:

	invoke	GetModuleHandle,NULL
	mov		hInstance,eax
	mov		icex.dwSize, sizeof INITCOMMONCONTROLSEX
	mov		icex.dwICC, ICC_COOL_CLASSES or ICC_BAR_CLASSES or ICC_USEREX_CLASSES
	invoke	InitCommonControlsEx, addr icex
	invoke	DialogBoxParam, hInstance, IDD_MAINDIALOG, NULL, addr DlgProc, NULL
	invoke	ExitProcess, 0


DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	rbbi			:REBARBANDINFO
	LOCAL	TempBuff [52]	:BYTE


	.if uMsg==WM_INITDIALOG
		
		invoke	LoadIcon, hInstance, 1
		invoke	SendMessage, hWnd, WM_SETICON, ICON_BIG	, eax
		
		invoke	GetDlgItem, hWnd, IDC_TBR1
		mov		hToolbar1, eax
		invoke	LoadBitmap, hInstance, IDR_MENUIMG
		invoke	DoToolBar, hToolbar1, eax, addr TbStrings1, ntbrbtns1, addr tbrbtns1
		invoke	SetWindowLong, hToolbar1, GWL_WNDPROC, addr ToolbarSubClass
		invoke	SetWindowLong, hToolbar1, GWL_USERDATA, eax
		
		invoke	GetDlgItem, hWnd, IDC_TBR2
		mov		hToolbar2, eax
		invoke	LoadBitmap, hInstance, IDR_MENUIMG2
		invoke	DoToolBar, hToolbar2, eax, addr TbStrings2, ntbrbtns2, addr tbrbtns2
		invoke	SetWindowLong, hToolbar2, GWL_WNDPROC, addr ToolbarSubClass
		invoke	SetWindowLong, hToolbar2, GWL_USERDATA, eax
		
		invoke	GetDlgItem, hWnd, IDC_TBR3
		mov		hToolbar3, eax
		invoke	LoadBitmap, hInstance, IDR_MENUIMG3
		invoke	DoToolBar, hToolbar3, eax, addr TbStrings3, ntbrbtns3, addr tbrbtns3
		invoke	SetWindowLong, hToolbar3, GWL_WNDPROC, addr ToolbarSubClass
		invoke	SetWindowLong, hToolbar3, GWL_USERDATA, eax
		
		invoke	GetDlgItem, hWnd, IDC_REB1
		mov		hRebar, eax
		mov		rbbi.cbSize, sizeof REBARBANDINFO
		mov		rbbi.fMask, RBBIM_STYLE or RBBIM_CHILD or RBBIM_SIZE or RBBIM_CHILDSIZE or RBBIM_HEADERSIZE or RBBIM_TEXT
		mov		rbbi.fStyle, RBBS_CHILDEDGE or RBBS_GRIPPERALWAYS or RBS_BANDBORDERS 
		push	hToolbar1
		pop		rbbi.hwndChild
		mov		rbbi.lx, 0
		mov		rbbi.cyMinChild, 90
		mov		rbbi.cxMinChild, 0
		mov		rbbi.cxHeader, 22
		mov		rbbi.lpText, offset RbrObjects
		mov		rbbi.cch, 30
		invoke	SendMessage, hRebar, RB_INSERTBAND, 0, addr rbbi
		push	hToolbar2
		pop		rbbi.hwndChild
		mov		rbbi.lpText, offset RbrGroups
		invoke	SendMessage, hRebar, RB_INSERTBAND, 1, addr rbbi
		push	hToolbar3
		pop		rbbi.hwndChild
		mov		rbbi.lpText, offset RbrAbout
		invoke	SendMessage, hRebar, RB_INSERTBAND, 2, addr rbbi
		invoke	SetWindowLong, hRebar, GWL_WNDPROC, addr RebarSubClass
		invoke	SetWindowLong, hRebar, GWL_USERDATA, eax
		
		invoke	CheckIsThemeActive
		.if eax!=0
			invoke	CreateSolidBrush, MouseOverTheme
			mov		MouseOverBrush, eax
			invoke	CreateSolidBrush, MsOvr_ChekedBtnTheme
			mov		MsOvr_ChekedBtnBrush, eax
			invoke	CreateSolidBrush, ChekedButtonTheme
			mov		ChekedButtonBrush, eax
		.else
			invoke	CreateSolidBrush, MouseOverClassic
			mov		MouseOverBrush, eax
			invoke	CreateSolidBrush, MsOvr_ChekedBtnClassic
			mov		MsOvr_ChekedBtnBrush, eax
			invoke	CreateSolidBrush, ChekedButtonClassic
			mov		ChekedButtonBrush, eax
		.endif
		invoke	CreateSolidBrush, 00000000h
		mov		BlackBrush, eax
		
		invoke	CheckRadioButton, hWnd, IDC_RBN1, IDC_RBN2, IDC_RBN2
		
	.elseif uMsg==WM_COMMAND
		
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		
		.if edx==BN_CLICKED
			
			.if eax>=IDT_TOOLBAR1 && eax<=IDT_TOOLBAR1+6
				
				mov		edx, eax
				invoke	SendMessage, hToolbar1, TB_GETBUTTONTEXT, edx, addr TempBuff
				invoke	SendDlgItemMessage, hWnd, IDC_STC1, WM_SETTEXT, 0, addr TempBuff
				invoke	UncheckTBButton, hToolbar2
				invoke	UncheckTBButton, hToolbar3
				
			.elseif eax==IDT_TOOLBAR2
				
				mov		edx, eax
				invoke	SendMessage, hToolbar2, TB_GETBUTTONTEXT, edx, addr TempBuff
				invoke	SendDlgItemMessage, hWnd, IDC_STC1, WM_SETTEXT, 0, addr TempBuff
				invoke	UncheckTBButton, hToolbar1
				invoke	UncheckTBButton, hToolbar3
				
			.elseif eax==IDT_TOOLBAR3
				
				invoke	SendDlgItemMessage, hWnd, IDC_STC1, WM_SETTEXT, 0, addr AboutMsg
				invoke	UncheckTBButton, hToolbar1
				invoke	UncheckTBButton, hToolbar2
				
			.elseif eax==IDC_RBN1
				
				mov		ToolbarStyleID, TRUE
				invoke	InvalidateRect, hToolbar1, 0, TRUE
				invoke	InvalidateRect, hToolbar2, 0, TRUE
				invoke	InvalidateRect, hToolbar3, 0, TRUE
				
			.elseif eax==IDC_RBN2
				
				mov		ToolbarStyleID, FALSE
				invoke	InvalidateRect, hToolbar1, 0, TRUE
				invoke	InvalidateRect, hToolbar2, 0, TRUE
				invoke	InvalidateRect, hToolbar3, 0, TRUE
				
			.elseif eax==IDCANCEL
				
				invoke	SendMessage, hWnd, WM_CLOSE, NULL, NULL
				
			.endif
			
		.endif
		
	.elseif uMsg==WM_THEMECHANGED
		
		invoke	DeleteObject, MouseOverBrush
		invoke	DeleteObject, MsOvr_ChekedBtnBrush
		invoke	DeleteObject, ChekedButtonBrush
		invoke	CheckIsThemeActive
		.if eax!=0
			invoke	CreateSolidBrush, MouseOverTheme
			mov		MouseOverBrush, eax
			invoke	CreateSolidBrush, MsOvr_ChekedBtnTheme
			mov		MsOvr_ChekedBtnBrush, eax
			invoke	CreateSolidBrush, ChekedButtonTheme
			mov		ChekedButtonBrush, eax
		.else
			invoke	CreateSolidBrush, MouseOverClassic
			mov		MouseOverBrush, eax
			invoke	CreateSolidBrush, MsOvr_ChekedBtnClassic
			mov		MsOvr_ChekedBtnBrush, eax
			invoke	CreateSolidBrush, ChekedButtonClassic
			mov		ChekedButtonBrush, eax
		.endif
		
	.elseif uMsg==WM_SIZE
		
		invoke	MoveWindow, hRebar, 10, 10, 96, 240, TRUE
		
	.elseif uMsg==WM_CLOSE
		
		invoke EndDialog,hWnd,0
		
	.else
		
		mov		eax,FALSE
		ret
		
	.endif
	
	mov		eax,TRUE
	ret

DlgProc endp


ToolbarSubClass proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	ToolbarOldProc	:DWORD
	LOCAL	hdc				:DWORD
	LOCAL	hFont			:DWORD
	LOCAL	hOldFont		:DWORD
	LOCAL	iBitmap			:DWORD
	LOCAL	rect			:RECT	
	LOCAL	tb				:TBBUTTON
	LOCAL	TBuff [52]		:BYTE


	invoke	GetWindowLong, hWnd, GWL_USERDATA
	mov		ToolbarOldProc, eax
	invoke	CallWindowProc, ToolbarOldProc, hWnd, uMsg, wParam, lParam
	.if ToolbarStyleID==FALSE
		.if uMsg==WM_PAINT
			invoke	DrawCheckButton, hWnd
			invoke	GetDC, hWnd
			mov		hdc, eax
			invoke	SendMessage, hWnd, TB_GETHOTITEM, 0, 0
			.if eax!=-1
				mov		ebx, eax
				invoke	SendMessage, hWnd, TB_GETBUTTON, ebx, addr tb
				invoke	SendMessage, hWnd, TB_GETITEMRECT, ebx, addr rect
				invoke	FrameRect, hdc, addr rect, BlackBrush
				invoke	InflateRect, addr rect, -1, -1
				invoke	SendMessage, hWnd, TB_ISBUTTONCHECKED, tb.idCommand, 0
				.if eax!=0
					invoke	FillRect, hdc, addr rect, MsOvr_ChekedBtnBrush
				.else
					invoke	FillRect, hdc, addr rect, MouseOverBrush
				.endif
				invoke	SendMessage, hWnd, TB_GETBITMAP, tb.idCommand, 0
				mov		iBitmap, eax
				invoke	SendMessage, hWnd, TB_GETIMAGELIST, 0, 0
				mov		ecx, rect.left
				add		ecx, 4
				mov		edx, rect.top
				add		edx, 2
				invoke	ImageList_Draw, eax, iBitmap, hdc, ecx, edx, ILD_NORMAL
				invoke	SendMessage, hWnd, WM_GETFONT, 0, 0
				mov		hFont, eax
				invoke	SelectObject, hdc, eax
				mov		hOldFont, eax
				invoke	SetBkMode, hdc, TRANSPARENT
				invoke	SetBkColor, hdc, TRANSPARENT
				invoke	SetTextColor, hdc, 00000000h
				invoke	SendMessage, hWnd, TB_GETBUTTONTEXT, tb.idCommand, addr TBuff
				mov		ecx, eax
				add		rect.left, 22
				invoke	DrawText, hdc, addr TBuff, ecx, addr rect, DT_VCENTER or DT_SINGLELINE
				invoke	SelectObject, hdc, hOldFont
				invoke	DeleteDC, hdc
			.endif
		.endif
	.endif
	ret
	
ToolbarSubClass endp


DrawCheckButton proc uses ebx esi hWnd:HWND
	LOCAL	hdc				:DWORD
	LOCAL	hFont			:DWORD
	LOCAL	hOldFont		:DWORD
	LOCAL	iBitmap			:DWORD
	LOCAL	rect			:RECT	
	LOCAL	tb				:TBBUTTON
	LOCAL	TempBuff [52]	:BYTE
	
	invoke	GetDC, hWnd
	mov		hdc, eax
	invoke	SendMessage, hWnd, TB_BUTTONCOUNT, 0, 0
	mov		esi, eax
	xor		ebx, ebx
	.while ebx<esi
		invoke	SendMessage, hWnd, TB_GETBUTTON, ebx, addr tb
		invoke	SendMessage, hWnd, TB_ISBUTTONCHECKED, tb.idCommand, 0
		.if eax!=0
			invoke	SendMessage, hWnd, TB_GETITEMRECT, ebx, addr rect
			invoke	FrameRect, hdc, addr rect, BlackBrush
			invoke	InflateRect, addr rect, -1, -1
			invoke	FillRect, hdc, addr rect, ChekedButtonBrush
			invoke	SendMessage, hWnd, TB_GETBUTTON, ebx, addr tb
			invoke	SendMessage, hWnd, TB_GETBITMAP, tb.idCommand, 0
			mov		iBitmap, eax
			invoke	SendMessage, hWnd, TB_GETIMAGELIST , 0, 0
			mov		ecx, rect.left
			add		ecx, 4
			mov		edx, rect.top
			add		edx, 2
			invoke	ImageList_Draw, eax, iBitmap, hdc, ecx, edx, ILD_NORMAL
			invoke	SendMessage, hWnd, WM_GETFONT, 0, 0
			mov		hFont, eax
			invoke	SelectObject, hdc, eax
			mov		hOldFont, eax
			invoke	SetBkMode, hdc, TRANSPARENT
			invoke	SetBkColor, hdc, TRANSPARENT
			invoke	SetTextColor, hdc, 00000000h			
			invoke	SendMessage, hWnd, TB_GETBUTTONTEXT, tb.idCommand, addr TempBuff
			mov		ecx, eax
			add		rect.left, 22
			invoke	DrawText, hdc, addr TempBuff, ecx, addr rect, DT_VCENTER or DT_SINGLELINE
			invoke	SelectObject, hdc, hOldFont
			invoke	DeleteDC, hdc
		.endif
		inc		ebx
	.endw
	ret

DrawCheckButton endp


RebarSubClass proc uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL	RebarOldProc	:DWORD
	LOCAL	hdc				:DWORD
	LOCAL	hFont			:DWORD
	LOCAL	hOldFont		:DWORD
	LOCAL	BandCount		:DWORD
	LOCAL	rect			:RECT
	LOCAL	rbbi			:REBARBANDINFO
	LOCAL	TempBuff [52]	:BYTE

	invoke	RtlZeroMemory, addr rbbi, sizeof REBARBANDINFO
	invoke	GetWindowLong, hWnd, GWL_USERDATA
	mov		RebarOldProc, eax
	invoke	CallWindowProc, RebarOldProc, hWnd, uMsg, wParam, lParam
	.if uMsg==WM_PAINT
		invoke	SendMessage, hWnd, RB_GETBANDCOUNT, 0, 0
		mov		BandCount, eax
		xor		ebx, ebx
		.while ebx<BandCount
			invoke	GetDC, hWnd
			mov		hdc, eax
			mov		rbbi.cbSize, sizeof REBARBANDINFO
			mov		rbbi.fMask, RBBIM_TEXT 
			mov		rbbi.fStyle, 0
			lea		eax, TempBuff
			mov		rbbi.lpText, eax
			mov		rbbi.cch, 256
			invoke	SendMessage, hWnd, RB_GETBANDINFO, ebx, addr rbbi
			invoke	SendMessage, hWnd, RB_GETRECT, ebx, addr rect
			.if rect.left!=0
				push	rect.left
				pop		rect.top
			.endif
			mov		rect.left, 2
			inc		rect.top
			mov		rect.right, 92
			push	rect.top
			pop		rect.bottom 
			add		rect.bottom, 21
			invoke	GetSysColorBrush, COLOR_3DFACE
			invoke	FillRect, hdc, addr rect, eax
			invoke	DrawEdge, hdc, addr rect, BDR_RAISEDINNER, BF_RECT  
			invoke	SendMessage, hWnd, WM_GETFONT, 0, 0
			mov		hFont, eax
			invoke	SelectObject, hdc, eax
			mov		hOldFont, eax
			invoke	SetBkMode, hdc, TRANSPARENT
			invoke	SetBkColor, hdc, TRANSPARENT
			invoke	SetTextColor, hdc, 00000000h
			invoke	lstrlen, addr TempBuff
			mov		ecx, eax
			invoke	DrawText, hdc, addr TempBuff, ecx, addr rect, DT_VCENTER or DT_CENTER or DT_SINGLELINE
			invoke	SelectObject, hdc, hOldFont
			invoke	DeleteDC, hdc
			inc		ebx
		.endw
	.endif
	ret
	
RebarSubClass endp


UncheckTBButton proc uses ebx esi hWnd:HWND
	LOCAL	tb		:TBBUTTON
	
	invoke	SendMessage, hWnd, TB_BUTTONCOUNT, 0, 0
	mov		esi, eax
	xor		ebx, ebx
	.while ebx<esi
		invoke	SendMessage, hWnd, TB_GETBUTTON, ebx, addr tb
		invoke	SendMessage, hWnd, TB_CHECKBUTTON, tb.idCommand, FALSE
		inc		ebx
	.endw
	ret

UncheckTBButton endp


DoToolBar proc hTBr:HWND, hBmp:DWORD, lpString:DWORD, NmBtn, tbbtns:DWORD
	LOCAL	tbab		:TBADDBITMAP
	LOCAL	rect		:RECT
	LOCAL	hImgList	:DWORD

	invoke	SendMessage, hTBr, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
	mov		ecx, 16
	mov		eax, 16
	shl		eax, 16
	mov		ax, cx
	invoke	SendMessage, hTBr, TB_SETBITMAPSIZE, 0, eax
	invoke	ImageList_Create, 16, 16, ILC_MASK or ILC_COLOR24, 20, 20 ; 
	mov		hImgList, eax
	invoke	GetMaskColor, hBmp
	invoke	ImageList_AddMasked, hImgList, hBmp, eax
	invoke	SendMessage, hTBr, TB_SETIMAGELIST, 0, hImgList
	invoke	SendMessage, hTBr, TB_ADDSTRING, 0, lpString	
	invoke	SendMessage, hTBr, TB_ADDBUTTONS, NmBtn, tbbtns
	invoke	SendMessage, hTBr, TB_SETBUTTONSIZE, 16, 90
	mov		eax, hTBr
	ret

DoToolBar endp


GetMaskColor proc hBitmap:DWORD
	LOCAL	mDC			:DWORD
	LOCAL	hBrush		:DWORD
	LOCAL	hOldBmp		:DWORD

	invoke	CreateCompatibleDC, NULL
	mov		mDC, eax
	invoke	SelectObject, mDC, hBitmap
	mov		hOldBmp, eax
	invoke	GetPixel, mDC, 0, 0
	push	eax
	invoke	SelectObject, mDC, hBitmap
	invoke	DeleteDC, mDC
	pop		eax 
    ret

GetMaskColor endp


CheckIsThemeActive proc uses ebx esi
	
	xor		ebx, ebx
	invoke	LoadLibrary, addr UxthemeDLL
	.if eax!=0
		mov		esi, eax
		invoke	GetProcAddress, eax, addr strIsThemeActive
		.if eax!=0
			call	eax
			mov		ebx, eax
		.endif
		invoke	FreeLibrary, esi
	.endif
	mov		eax, ebx
	ret

CheckIsThemeActive endp


end start


